<?php
/**
 * @name avaibility
 * @description construction du block avaibility dans les rapports
 *		Tous les blocs avaibility passent par ce code pour construire le graph, donut,...
 * @author Victor Marin <v.marin@esia-sa.com>
 * @date Mars 2017
 */
require_once '/usr/local/esia/public_html/plugin/report/report.conf.php';
require_once REPORT_COMMON_BLOCK;
$params = $block['parameters'];
$template_path = $path.'/plugin/report/blocks/templates/';

//UPDATE interface web
if($action=="generate")
{
    
    
    $plugins = Model_esia::getPlugin($dbconnection);
    $select_plugins=explode(',', $params['tag']);
    $valid_plugin=array();
    foreach ($plugins as $plugin)
    {
        foreach($select_plugins as $tag )
        {
            if(stristr($plugin['tag'], $tag))
            {
                $valid_plugin[] = $plugin['id'];
            }
        }
    }
    $nodes = array();
    if($params['element_type']=='group_node')
    {
        $nodes = Model_esia::getAllNodeofGroup($dbconnection, null, $params['element_dbid']);
    }
    else 
    {
        foreach ($params['element_dbid'] as $nodeid)
        {
            try
            {
                $infonode=Model_esia::InstanceNode($dbconnection,$nodeid);
                $nodes[]=$infonode;      
            }
            catch(Exception $e)
            {
                
            }
        }	
    }
    $list = array();
    foreach($nodes as $node)
    {
        $services = Model_esia::getServices($dbconnection, $node->getId());
        foreach($services as $service)
        {
            if(in_array($service['plugin_id'],$valid_plugin  ))
            {
                $errors = Model_Report::getEsiaErrorServiceId($dbconnection,$service['id'],$start,$end);
                //print_r($errors);
                if(!empty($errors)) 
                { 
                    foreach($errors as $error)
                    {
                       // echo $service['name'].' '.$error['error_type'].' '.$params['calcunknown'].' '.$params['calcwarning'].'<br />' ;
                        if($error['error_type'] == 'unknown' && $params['calcunknown'] == 'on')
                        {
                            $list[]=$error;
                        }
                        elseif($error['error_type'] == 'warning' && $params['calcwarning'] == 'on')
                        {
                            $list[]=$error;
                        }
                        elseif($error['error_type'] == 'critical' && $params['calccritical'] == 'on')
                        {
                            $list[]=$error;
                        }
                    }
                }
            }
        }
    }
    if(empty($params['form']))
    {
        $params['form']='tab2';
    }
   
    $lines = array();
    foreach ($list as $line)
    {
        $common_name = Model_esia::getCommonName($lang, $line['service_name'], $line['plugin_name']);
        $lines[] = array('device_group_name' => $line['device_group_name'],
                              'device_name' => $line['device_name'],
                              'device_ip_addr' => long2ip($line['device_ip_addr']),
                              'description' => $line['description'],
                              'common_name' => $common_name,
                              'service_name' => $line['service_name'],
                              'error_type' => $line['error_type'],
                              'happen_message' => $line['happen_message'],
                              'time_end' => $line['time_end'],
                              'during' => $line['during'],
                              );
        
    }
    
    $smarty->assign('lines',$lines);
    
}
elseif($action=="node")
{
    $nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
    $list=array();
    
    foreach($nodes as $node)
    {
        $arr = array('id'=>$node->getId(),'parent_name'=>$node->getGroup().'>'.$node->getName());
        if($params['element_type']=='node')
        {
            if(in_array($node->getId(),$params['element_dbid']))
            {
                $arr['selected']=1;
            }
        }
        $list[]= $arr;
    }
    echo json_encode($list);
}
elseif($action=="group_node")
{
	$parameters = $block['parameters'];
	if(empty($parameters['element_type']))
	{
		$parameters['element_type']='group_node';
	}
	$arr = Model_esia::getGroupDevice($dbconnection,null,$user->getId());
	$list_group_node =array();
	if($parameters['element_type']=='group_node')
	{
		foreach($arr as $group)
		{
			$line = array('id'=>$group['id'],'parent_name'=>$group['fullpath']);
			
			if(in_array($group['id'],$parameters['element_dbid']))
			{
				$line['selected']=1;
			}
			$list_group_node[]=$line;
		}
	}
	echo json_encode($list_group_node);
	exit(0);    
}
elseif($action=="update")
{
    //echo var_dump($block);
	$params = $block['parameters'];
    $smarty->assign('blockid',$block['include_id']);
    $smarty->assign('canevas_id',$block['include_canevas_id']);
    if(isset($_POST['blockid'])&&!empty($_POST['blockid']))
    {
        try
        {
        	$block = getPostDefaultParams($block,$_POST);
        	$parameters = $block['parameters'];
            //
            // Forme
        	$parameters['form']=$_POST['form'];
            // Seuil de Warning et Critical
        	$parameters['criticalThreshold']=$_POST['criticalThreshold'];
        	$parameters['warningThreshold']=$_POST['warningThreshold'];
            
            // Calcul de la dispo
            if( empty($_POST['calcunknown']) )	$_POST['calcunknown'] = 'none';
            if( empty($_POST['calcwarning']) )	$_POST['calcwarning'] = 'none';
            if( empty($_POST['calccritical']) )	$_POST['calccritical'] = 'none';
            $parameters['calcunknown']=$_POST['calcunknown'];
            $parameters['calcwarning']=$_POST['calcwarning'];
            $parameters['calccritical']=$_POST['calccritical'];
            //
            if( empty($_POST['plugin_tag']) )
            {
            	$parameters['tag']='RAID,HEALTH';
            }
            else 
            {
            	$parameters['tag']= $_POST['plugin_tag'];
            }
            //Paramètre du tableau
            if( empty($_POST['tab_col_group']) )	$_POST['tab_col_group'] = 'none';
            if( empty($_POST['tab_col_ip']) )	$_POST['tab_col_ip'] = 'none';
            if( empty($_POST['tab_col_descr']) )	$_POST['tab_col_descr'] = 'none';
            if( empty($_POST['tab_col_technical_name']) )    $_POST['tab_col_technical_name'] = 'none';
            if( empty($_POST['tab_error_msg']) )	$_POST['tab_error_msg'] = 'none';
            if( empty($_POST['tab_col_time_end']) )   $_POST['tab_col_time_end'] = 'none';
            if( empty($_POST['tab_col_during']) )   $_POST['tab_col_during'] = 'none';
    
            $parameters['table']['columnshow']['group']=$_POST['tab_col_group'];
            $parameters['table']['columnshow']['ip']=$_POST['tab_col_ip'];
            $parameters['table']['columnshow']['description']=$_POST['tab_col_descr'];
            $parameters['table']['columnshow']['technical_name']=$_POST['tab_col_technical_name'];
            $parameters['table']['columnshow']['message']=$_POST['tab_error_msg'];
            $parameters['table']['columnshow']['time_end']=$_POST['tab_col_time_end'];
            $parameters['table']['columnshow']['during']=$_POST['tab_col_during'];
    
            //Type d'affichage
            $parameters['element_type']=$_POST['select_type_link'];
            $parameters['element_dbid']=$_POST['elementselect'];
           
            $paramSave = json_encode($parameters);
            Model_Report::UpdtReportIncludeBlock($dbconnection,$block['id'],$block['include_block_id'],$block['include_canevas_id'],$block['include_position'],$paramSave);
            $smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
            $block['option']=$parameters;
            $smarty->assign('block',$block);
        }
        catch (EsiaDbException $e)
		{
            //la variable l_error est affichée en rouge dans le smarty
			$smarty->assign('l_error',$e->getMessage());
            
		}
		catch (Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
            
		}   
		$smarty->assign('block',$block);
		$smarty->assign('parameters',$parameters);
    }
    //explode pour le formulaire afin de spécifier la taille dans un input type numéric
    //recupération des styles
    assignCommonStyles($smarty,$parameters);
    $smarty->assign('action','update');   
    
}
$smarty->display($template_path.'hardware_incident.html');
?>
