<?php
require_once '/usr/local/esia/public_html/plugin/report/report.conf.php';
require_once REPORT_COMMON_BLOCK;
require_once '/usr/local/esia/public_html/plugin/inventory/Model_inventory.php';

if($action == 'generate')
{
    //code qui va générer l'HTML du bloc (attention en CRON au DOCUMENT_ROOT qui n'existe pas

    // Get user Id for devices access rights
    $userId = NULL;
    if(@is_null($user) == FALSE)
    {
        // Current user for generate now
        $userId = $user->getId();
    }
    else
    {
        // User canvas creation for automatic generation
        $userId = Model_Report::getOwnerCanevas($dbconnection, $block['include_canevas_id'])[0];
    }

    $parameters = $block['parameters'];
    
    // Chart type
    if(empty($parameters['graphic']))
    {
        $parameters['graphic'] = 'DONUT';
    }

    // Manufacturers data
    if(!isset($parameters['nodeid']))
    {
        $parameters['nodeid'] = NULL;
    }
    if(!isset($parameters['groupnodeid']))
    {
        $parameters['groupnodeid'] = NULL;
    }
    if(!isset($parameters['target']))
    {
        $parameters['target'] = NULL;
    }
    if(!isset($parameters['limit']))
    {
        $parameters['limit'] = NULL;
    }
    $manufacturers = Model_inventory::getCountManufacturer($dbconnection, $userId, $parameters['nodeid'], $parameters['groupnodeid'], $parameters['target'], $parameters['limit']);

    // Legend
    $legendPos = 'bottom';
    if(isset($parameters['legend_position']) && $parameters['legend_position'] == 'RIGHT')
    {
        $legendPos = 'right';
    }

    $smarty->assign('inclusion', $block['include_id']);
    $smarty->assign('type_graphic', $parameters['graphic']);
    $smarty->assign('manufacturers', $manufacturers);
    $smarty->assign('legendPos', $legendPos);
}
elseif($action == 'update')
{
    if(!empty($_POST['blockid']))
    {
        try
        {
            //traite les données post pour le style du titre et de la description
            $block = getPostDefaultParams($block,$_POST);

            $parameters = $block['parameters'];
            //traitement des variable POST

            if($parameters['type']=='noeud')
            {
                $parameters['nodeid']=$_POST['nodes'];
            }
            elseif($parameters['type']=='group_node')
            {
                $parameters['groupnodeid']=$_POST['groupnodes'];
            }
            else
            {
                $parameters['type']='global';
            }
            $parameters['component_description']=$_POST['component_description'];
            $parameters['graphic']=$_POST['graphic'];
            $parameters['hardware'] =$_POST['hardware'];
            $parameters['software'] =$_POST['software'];
            $parameters['target'] = $_POST['target'];
            $parameters['legend_position'] = $_POST['legend_position'];
            $parameters['limit'] = $_POST['limit'];
            
            $paramSave = json_encode($parameters);
            Model_Report::UpdtReportIncludeBlock($dbconnection,$block['id'],$block['include_block_id'],$block['include_canevas_id'],$block['include_position'],$paramSave);
            //la variable l_success est affichée en rouge dans le smarty
            $smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
            $block['option']=$parameters;
            $smarty->assign('block',$block);
        }
        catch(EsiaDbException $e)
        {
            //la variable l_error est affichée en rouge dans le smarty
            $smarty->assign('l_error',$e->getMessage());
        }
        catch(Exception $e)
        {
            $smarty->assign('l_error',$e->getMessage());
        }
    }
    
    //recupération des styles
    assignCommonStyles($smarty,$parameters);
    $smarty->assign('limit',(int)$parameters['limit']);
        
    if($parameters['type']=="noeud")
    {
        //Récupération des noeuds
        $nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
        $list=array();
        foreach($nodes as $node)
        {
            $selected = 'no';
            if(in_array($node->getId(), $parameters['nodeid']))
            {
                $selected = 'yes';
            }
            $list[] = array(
                'id' => $node->getId(),
                'name' => $node->getGroup() . '>' . $node->getName(),
                'selected' => $selected,
            );
        }
    }
    if($parameters['type'] =="group_node")
    {
        $groupNode = Model_esia::getGroupDeviceIn($dbconnection);
        
        $arr = Model_esia::getGroupDevice($dbconnection,null,$user->getId());
        $list_group_node = array();
        foreach($arr as $group)
        {
            $select = 'no';
            if(in_array($group['id'], $parameters['groupnodeid']))
            {
                $select = 'yes';
            }
            $list_group_node[] = array(
                'id' => $group['id'],
                'name' => $group['fullpath'],
                'selected' => $select,
            );
        }         
        $smarty->assign('adm_list_group_node', $list_group_node);
    }

    $smarty->assign('adm_list_node', $list);

    if(empty($parameters['graphic']))
    {
        $parameters['graphic'] = 'DONUT';
    }

    $smarty->assign('param', $parameters);

    //on fixe le mode update
    $smarty->assign('action','update');
}
//chemin d'accès au template de votre block
$smarty->display($webplugin_path.'blocks/templates/inventory_manufacturer.html');
?>
