#!/usr/bin/php
<?php
/**
 * @name report_generate_cron
 * @description fichier qui s'execute grace à la tache cron
 *		Genere les rapports du jour et les envoie aux personnes interessées
 * @author Victor Marin <v.marin@esia-sa.com>
 * @date Mars 2017
 */

$_SERVER['DOCUMENT_ROOT']='/usr/local/esia/public_html/';
$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
include $path.'/esia.conf.php';
include_once MVCMODEL;
include_once $path.'/Model_adm.php';
include_once 'Model_Report.php';


$SHORT_OPTS = 'D';
$LONG_OPTS = array('debug');
$options = getopt($SHORT_OPTS, $LONG_OPTS);
$debug   = (isset($options['D']) || isset($options['debug']));

$ret_val = 0;

try
{
	$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
	$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
}
catch(Exception $e)
{
	echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
	echo 'N° : '.$e->getCode();
}

// Info Mail
$serveur     = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_SMTP");
$utilisateur = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_USER");
$passwordMail= Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_PASSWORD");
$sll_mail    = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_SSL");
$port 		 = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_SMTP_PORT");
$expiditor   = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_FROM");
$fqdn		 = Model_esia::getConfiguration($dbconnection,"ESIA_URL");
$query=Model_Report::getReportCanevas($dbconnection);
$ListUser = Model_adm::searchUser($dbconnection);
$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_REPORT');
$path_report = $path.$arr[0]['apache_path'];

foreach ($query as $Canevas)
{
	if(!empty($Canevas)&& $Canevas!=null)
	{
		$End = $Canevas['canevas_date_nextgeneration'];
		$param_canevas = json_decode($Canevas['canevas_parameter'],true);
	
		$End = date_format(new DateTime($End),'Y-m-d');
	 	$today = date("Y-m-d");

		$report_info = 'Report : '.$Canevas['canevas_name'].' interval : '. $Canevas['canevas_interval'] . " NextGen : $End Today : $today ";
        if($End<=$today) // Verifie la date du jour
	 	{	
			trace($debug, "$report_info GENERATE");
	 		if(isset($param_canevas['lang']))
	 		{
				$cmd = "php ".$path_report."report_generate.php -a generate -i ".$Canevas['canevas_id']." -n '".$param_canevas['title']['text']."' -l '".$param_canevas['lang']."'";
	 		}
	 		else
	 		{
				$cmd = "php ".$path_report."report_generate.php -a generate -i ".$Canevas['canevas_id']." -n '".$param_canevas['title']['text']."' -l 'fr'";
	 		}
            trace($debug, "->Generate : $cmd");
			shell_exec($cmd);

			$ListReport = Model_Report::getReport_of_ReportCanevas($dbconnection,$Canevas['canevas_id'],$today);
			$report = end($ListReport);
			foreach ($param_canevas['ListUser'] as $sendu)
	 		{		 		
	 			
	 			if (array_key_exists($sendu,$ListUser))
		 		{					
		 			
		 			$u = $ListUser[$sendu];
		 			$sujet = $param_canevas['SubjetMail'];
		 			$data = $param_canevas['TextMail'];
		 			
					$sujet= preg_replace('#\'#','\'\\\'\'',$sujet);			
					$data = preg_replace('#\\n#','<br>',$data);
					$data = preg_replace('#\'#','\'\\\'\'',$data);
					
					$exec = $path_report."send_mail.pl";
					$exec .=" -H '".cleanArgs($serveur['REPORT_MAIL_SMTP']['value'])."'";
					$exec .=" -p ".cleanArgs($port['REPORT_MAIL_SMTP_PORT']['value']);
					$exec .=" -S '".cleanArgs($sll_mail['REPORT_MAIL_SSL']['value'])."'";
					
					$exec .=" -e '".cleanArgs($expiditor['REPORT_MAIL_FROM']['value'])."'";
					$exec .=" -U '".cleanArgs($utilisateur['REPORT_MAIL_USER']['value'])."'";
					$exec .=" -P '".cleanArgs($passwordMail['REPORT_MAIL_PASSWORD']['value'])."'";
					$exec .=" -T '".cleanArgs($u['mail'])."'";
		 			$path_html=$report['path_html'];
		 			$path_html=preg_replace('#'.$_SERVER['DOCUMENT_ROOT'].'#','',$path_html);
		 			$path_html = rtrim($path_html,'/');
		 			$path_html = $fqdn['ESIA_URL']['value'].'/'.$path_html;
		 			$path_html = '<a href="'.$path_html.'">'.$path_html.'</a>';
		 			$sujet = preg_replace('#\$NAME#',$report['name'],$sujet);
		 			$data = preg_replace('#\$NAME#',$report['name'],$data);
		 			if(strpos($data, '$LINK')!==FALSE)
		 			{
		 				$data = preg_replace('#\$LINK#',$path_html,$data);
		 			}
		 			else
		 			{
		 				$data.=$path_html;
		 			}
                    $exec .=" -s '".escapeshellcmd($sujet)."' -d '".$data."'";

                    trace($debug, "-->Sendmail : $exec");
                    exec("$exec 2>&1",$output,$ret);
					if( $ret != 0 )
					{
						$ret_val == 1	;
						echo "ERROR :\n";
						echo implode("\n",$output);
					}
		 		}
		 	}
		 	
		 	$date = date_create($today);		 	
		 	if($Canevas['canevas_interval']=="1 mon")
		 	{
		 		date_add($date, date_interval_create_from_date_string('1 month'));
		 	}
		 	else
		 	{
		 		date_add($date, date_interval_create_from_date_string($Canevas['canevas_interval']));
            }
            trace($debug, "SET NextGen : ".date_format($date, 'd/m/Y')."\n");
		 	$query=Model_Report::UpdtReportCanevas($dbconnection,$Canevas['canevas_id'],$Canevas['canevas_name'],$Canevas['canevas_description'],$Canevas['canevas_interval'],date_format($date, 'd/m/Y'),$Canevas['canevas_parameter']);
		}
		else
		{
			trace($debug, "$report_info IGNORE");
		}
	}
}

//CLEAN DATABASE
$retention = Model_esia::getConfiguration($dbconnection,"REPORT_DURING");
$query=Model_Report::getOldReport($dbconnection,$retention['REPORT_DURING']['value']);
foreach($query as $report)
{
	$file=$report['path_html'];
	if(is_file($file))
	{
		unlink($file);
	}
	$file=$_SERVER['DOCUMENT_ROOT'].$report['path_pdf'];
	if(is_file($file))
	{
		unlink($file);
	}
	Model_Report::delReport($dbconnection, $report['id']);
}

if( $ret_val ==  0 )
{
    echo "Generate report : Exit success\n";
}
else
{
    echo "Generate report : Exit error\n";
}
exit($ret_val);


function trace($debug,$output)
{
        //if($debug==1 || $debug===true)
        if(isset($debug)  && $debug)
        {
                if(is_array($output))
                {
                        print_r($output);
                }
                else
                {
                        echo "DEBUG: $output\n";
                }
        }
}


function cleanArgs($val)
{
	$val = trim($val);
	$val = escapeshellcmd($val);
	return $val;
}
?>
